import { ElementRef } from '@angular/core';
/**
 * @private
 */
export declare class PointerEvents {
    private ele;
    private pointerDown;
    private pointerMove;
    private pointerUp;
    private zone;
    private option;
    private rmTouchStart;
    private rmTouchMove;
    private rmTouchEnd;
    private rmMouseStart;
    private rmMouseMove;
    private rmMouseUp;
    private lastTouchEvent;
    mouseWait: number;
    constructor(ele: any, pointerDown: any, pointerMove: any, pointerUp: any, zone: boolean, option: any);
    private handleTouchStart(ev);
    private handleMouseDown(ev);
    private handleTouchEnd(ev);
    private handleMouseUp(ev);
    stop(): void;
    destroy(): void;
}
/**
 * @private
 */
export declare class UIEventManager {
    zoneWrapped: boolean;
    private events;
    constructor(zoneWrapped?: boolean);
    listenRef(ref: ElementRef, eventName: string, callback: any, option?: any): Function;
    pointerEventsRef(ref: ElementRef, pointerStart: any, pointerMove: any, pointerEnd: any, option?: any): PointerEvents;
    pointerEvents(element: any, pointerDown: any, pointerMove: any, pointerUp: any, option?: any): PointerEvents;
    listen(element: any, eventName: string, callback: any, option?: any): Function;
    unlistenAll(): void;
}
